(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      9180,        484]*)
(*NotebookOutlinePosition[      9831,        507]*)
(*  CellTagsIndexPosition[      9787,        503]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Exhaustive Search", "Title"],

Cell["\<\
We're going to write a function that will search for the private exponent of \
RSA. This is not a practical attack as I intend to show.\
\>", "Text"],

Cell["The function is as follows", "Text"],

Cell[BoxData[
    \(Search[e_, n_, start_, stop_] := 
      \[IndentingNewLine]Module[{m, c, current, i}, 
        \[IndentingNewLine] (*We\ first\ get\ the\ message\ and\ cipher*) 
          \[IndentingNewLine]m = 2; \[IndentingNewLine]c = PowerMod[m, e, n]; 
        \[IndentingNewLine]current = PowerMod[c, start, n]; 
        \[IndentingNewLine]For[i = start, i < stop, \(i++\), 
          \[IndentingNewLine]If[Mod[i, 100000] \[Equal] 0, Print[i]]; 
          \[IndentingNewLine]If[current \[Equal] m, Break[]]; 
          \[IndentingNewLine]current = Mod[c*current, n]]; 
        \[IndentingNewLine]i]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(key = GenerateRSAKey[5]\)], "Input"],

Cell[BoxData[
    \("Generating \!\(\(p\^--\)\) Strong prime"\)], "Print"],

Cell[BoxData[
    \("Generating \!\(\(p\^--\)\) Strong prime"\)], "Print"],

Cell[BoxData[
    \(RSAKey[83537, 10492289, 24759671]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(pub = GetPublic[key]; \)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(e = GetExponent[pub]\)], "Input"],

Cell[BoxData[
    \(83537\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(n = GetModulus[pub]\)], "Input"],

Cell[BoxData[
    \(24759671\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[Search[e, n, 1, n]]\)], "Input"],

Cell[BoxData[
    \(100000\)], "Print"],

Cell[BoxData[
    \(200000\)], "Print"],

Cell[BoxData[
    \(300000\)], "Print"],

Cell[BoxData[
    \(400000\)], "Print"],

Cell[BoxData[
    \(500000\)], "Print"],

Cell[BoxData[
    \(600000\)], "Print"],

Cell[BoxData[
    \(700000\)], "Print"],

Cell[BoxData[
    \(800000\)], "Print"],

Cell[BoxData[
    \(900000\)], "Print"],

Cell[BoxData[
    \(1000000\)], "Print"],

Cell[BoxData[
    \(1100000\)], "Print"],

Cell[BoxData[
    \(1200000\)], "Print"],

Cell[BoxData[
    \(1300000\)], "Print"],

Cell[BoxData[
    \(1400000\)], "Print"],

Cell[BoxData[
    \(1500000\)], "Print"],

Cell[BoxData[
    \(1600000\)], "Print"],

Cell[BoxData[
    \(1700000\)], "Print"],

Cell[BoxData[
    \(1800000\)], "Print"],

Cell[BoxData[
    \(1900000\)], "Print"],

Cell[BoxData[
    \(2000000\)], "Print"],

Cell[BoxData[
    \(2100000\)], "Print"],

Cell[BoxData[
    \(2200000\)], "Print"],

Cell[BoxData[
    \(2300000\)], "Print"],

Cell[BoxData[
    \(2400000\)], "Print"],

Cell[BoxData[
    \(2500000\)], "Print"],

Cell[BoxData[
    \(2600000\)], "Print"],

Cell[BoxData[
    \(2700000\)], "Print"],

Cell[BoxData[
    \(2800000\)], "Print"],

Cell[BoxData[
    \(2900000\)], "Print"],

Cell[BoxData[
    \(3000000\)], "Print"],

Cell[BoxData[
    \(3100000\)], "Print"],

Cell[BoxData[
    \(3200000\)], "Print"],

Cell[BoxData[
    \(3300000\)], "Print"],

Cell[BoxData[
    \(3400000\)], "Print"],

Cell[BoxData[
    \(3500000\)], "Print"],

Cell[BoxData[
    \(3600000\)], "Print"],

Cell[BoxData[
    \(3700000\)], "Print"],

Cell[BoxData[
    \(3800000\)], "Print"],

Cell[BoxData[
    \(3900000\)], "Print"],

Cell[BoxData[
    \(4000000\)], "Print"],

Cell[BoxData[
    \(4100000\)], "Print"],

Cell[BoxData[
    \(4200000\)], "Print"],

Cell[BoxData[
    \(4300000\)], "Print"],

Cell[BoxData[
    \(4400000\)], "Print"],

Cell[BoxData[
    \(4500000\)], "Print"],

Cell[BoxData[
    \(4600000\)], "Print"],

Cell[BoxData[
    \(4700000\)], "Print"],

Cell[BoxData[
    \(4800000\)], "Print"],

Cell[BoxData[
    \(4900000\)], "Print"],

Cell[BoxData[
    \(5000000\)], "Print"],

Cell[BoxData[
    \(5100000\)], "Print"],

Cell[BoxData[
    \(5200000\)], "Print"],

Cell[BoxData[
    \(5300000\)], "Print"],

Cell[BoxData[
    \(5400000\)], "Print"],

Cell[BoxData[
    \(5500000\)], "Print"],

Cell[BoxData[
    \(5600000\)], "Print"],

Cell[BoxData[
    \(5700000\)], "Print"],

Cell[BoxData[
    \(5800000\)], "Print"],

Cell[BoxData[
    \(5900000\)], "Print"],

Cell[BoxData[
    \(6000000\)], "Print"],

Cell[BoxData[
    \(6100000\)], "Print"],

Cell[BoxData[
    \(6200000\)], "Print"],

Cell[BoxData[
    \(6300000\)], "Print"],

Cell[BoxData[
    \(6400000\)], "Print"],

Cell[BoxData[
    \(6500000\)], "Print"],

Cell[BoxData[
    \(6600000\)], "Print"],

Cell[BoxData[
    \(6700000\)], "Print"],

Cell[BoxData[
    \(6800000\)], "Print"],

Cell[BoxData[
    \(6900000\)], "Print"],

Cell[BoxData[
    \(7000000\)], "Print"],

Cell[BoxData[
    \(7100000\)], "Print"],

Cell[BoxData[
    \(7200000\)], "Print"],

Cell[BoxData[
    \(7300000\)], "Print"],

Cell[BoxData[
    \(7400000\)], "Print"],

Cell[BoxData[
    \(7500000\)], "Print"],

Cell[BoxData[
    \(7600000\)], "Print"],

Cell[BoxData[
    \(7700000\)], "Print"],

Cell[BoxData[
    \(7800000\)], "Print"],

Cell[BoxData[
    \(7900000\)], "Print"],

Cell[BoxData[
    \(8000000\)], "Print"],

Cell[BoxData[
    \(8100000\)], "Print"],

Cell[BoxData[
    \(8200000\)], "Print"],

Cell[BoxData[
    \(8300000\)], "Print"],

Cell[BoxData[
    \(8400000\)], "Print"],

Cell[BoxData[
    \(8500000\)], "Print"],

Cell[BoxData[
    \(8600000\)], "Print"],

Cell[BoxData[
    \(8700000\)], "Print"],

Cell[BoxData[
    \(8800000\)], "Print"],

Cell[BoxData[
    \(8900000\)], "Print"],

Cell[BoxData[
    \(9000000\)], "Print"],

Cell[BoxData[
    \(9100000\)], "Print"],

Cell[BoxData[
    \(9200000\)], "Print"],

Cell[BoxData[
    \(9300000\)], "Print"],

Cell[BoxData[
    \(9400000\)], "Print"],

Cell[BoxData[
    \(9500000\)], "Print"],

Cell[BoxData[
    \(9600000\)], "Print"],

Cell[BoxData[
    \(9700000\)], "Print"],

Cell[BoxData[
    \(9800000\)], "Print"],

Cell[BoxData[
    \(9900000\)], "Print"],

Cell[BoxData[
    \(10000000\)], "Print"],

Cell[BoxData[
    \(10100000\)], "Print"],

Cell[BoxData[
    \(10200000\)], "Print"],

Cell[BoxData[
    \(10300000\)], "Print"],

Cell[BoxData[
    \(10400000\)], "Print"],

Cell[BoxData[
    \({762.470000000000069`\ Second, 10492289}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(mins = Floor[762/60]\)], "Input"],

Cell[BoxData[
    \(12\)], "Output"]
}, Open  ]],

Cell["\<\
So it ran for 12 minutes with a tiny sized RSA key. I wouln't try running it \
on a real, industry standard 2000-bit key. It would be faster to factorize \
the modulus and that would even take an enormous amount of time.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[FactorInteger[n]]\)], "Input"],

Cell[BoxData[
    \({0.0499999999999545252`\ Second, {{2459, 1}, {10069, 1}}}\)], "Output"]
}, Open  ]],

Cell["\<\
I factored the modulus in a very short time. This attack is just too slow for \
words.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Length[IntegerDigits[24759671, 2]]\)], "Input"],

Cell[BoxData[
    \(25\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["The Next Step", "Subtitle"],

Cell["\<\
Having guessed or found by chance or maybe by treachery the decrypting \
exponent, it is easy to finish the thing off and factor n. The algorithm is \
pretty straightforward and works very quickly. Click on the link below to \
open that notebook. \
\>", "Text"],

Cell[TextData[ButtonBox["09_guessed.nb",
  ButtonData:>{"09_guessd.nb", None},
  ButtonStyle->"Hyperlink"]], "Text"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"Microsoft Windows 3.0",
ScreenRectangle->{{0, 1024}, {0, 712}},
WindowSize->{431, 485},
WindowMargins->{{21, Automatic}, {Automatic, 53}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1731, 51, 34, 0, 105, "Title"],
Cell[1768, 53, 159, 3, 52, "Text"],
Cell[1930, 58, 42, 0, 33, "Text"],
Cell[1975, 60, 620, 10, 230, "Input"],

Cell[CellGroupData[{
Cell[2620, 74, 56, 1, 30, "Input"],
Cell[2679, 77, 74, 1, 25, "Print"],
Cell[2756, 80, 74, 1, 25, "Print"],
Cell[2833, 83, 67, 1, 29, "Output"]
}, Open  ]],
Cell[2915, 87, 59, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[2999, 92, 53, 1, 30, "Input"],
Cell[3055, 95, 39, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3131, 101, 52, 1, 30, "Input"],
Cell[3186, 104, 42, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3265, 110, 59, 1, 30, "Input"],
Cell[3327, 113, 39, 1, 25, "Print"],
Cell[3369, 116, 39, 1, 25, "Print"],
Cell[3411, 119, 39, 1, 25, "Print"],
Cell[3453, 122, 39, 1, 25, "Print"],
Cell[3495, 125, 39, 1, 25, "Print"],
Cell[3537, 128, 39, 1, 25, "Print"],
Cell[3579, 131, 39, 1, 25, "Print"],
Cell[3621, 134, 39, 1, 25, "Print"],
Cell[3663, 137, 39, 1, 25, "Print"],
Cell[3705, 140, 40, 1, 25, "Print"],
Cell[3748, 143, 40, 1, 25, "Print"],
Cell[3791, 146, 40, 1, 25, "Print"],
Cell[3834, 149, 40, 1, 25, "Print"],
Cell[3877, 152, 40, 1, 25, "Print"],
Cell[3920, 155, 40, 1, 25, "Print"],
Cell[3963, 158, 40, 1, 25, "Print"],
Cell[4006, 161, 40, 1, 25, "Print"],
Cell[4049, 164, 40, 1, 25, "Print"],
Cell[4092, 167, 40, 1, 25, "Print"],
Cell[4135, 170, 40, 1, 25, "Print"],
Cell[4178, 173, 40, 1, 25, "Print"],
Cell[4221, 176, 40, 1, 25, "Print"],
Cell[4264, 179, 40, 1, 25, "Print"],
Cell[4307, 182, 40, 1, 25, "Print"],
Cell[4350, 185, 40, 1, 25, "Print"],
Cell[4393, 188, 40, 1, 25, "Print"],
Cell[4436, 191, 40, 1, 25, "Print"],
Cell[4479, 194, 40, 1, 25, "Print"],
Cell[4522, 197, 40, 1, 25, "Print"],
Cell[4565, 200, 40, 1, 25, "Print"],
Cell[4608, 203, 40, 1, 25, "Print"],
Cell[4651, 206, 40, 1, 25, "Print"],
Cell[4694, 209, 40, 1, 25, "Print"],
Cell[4737, 212, 40, 1, 25, "Print"],
Cell[4780, 215, 40, 1, 25, "Print"],
Cell[4823, 218, 40, 1, 25, "Print"],
Cell[4866, 221, 40, 1, 25, "Print"],
Cell[4909, 224, 40, 1, 25, "Print"],
Cell[4952, 227, 40, 1, 25, "Print"],
Cell[4995, 230, 40, 1, 25, "Print"],
Cell[5038, 233, 40, 1, 25, "Print"],
Cell[5081, 236, 40, 1, 25, "Print"],
Cell[5124, 239, 40, 1, 25, "Print"],
Cell[5167, 242, 40, 1, 25, "Print"],
Cell[5210, 245, 40, 1, 25, "Print"],
Cell[5253, 248, 40, 1, 25, "Print"],
Cell[5296, 251, 40, 1, 25, "Print"],
Cell[5339, 254, 40, 1, 25, "Print"],
Cell[5382, 257, 40, 1, 25, "Print"],
Cell[5425, 260, 40, 1, 25, "Print"],
Cell[5468, 263, 40, 1, 25, "Print"],
Cell[5511, 266, 40, 1, 25, "Print"],
Cell[5554, 269, 40, 1, 25, "Print"],
Cell[5597, 272, 40, 1, 25, "Print"],
Cell[5640, 275, 40, 1, 25, "Print"],
Cell[5683, 278, 40, 1, 25, "Print"],
Cell[5726, 281, 40, 1, 25, "Print"],
Cell[5769, 284, 40, 1, 25, "Print"],
Cell[5812, 287, 40, 1, 25, "Print"],
Cell[5855, 290, 40, 1, 25, "Print"],
Cell[5898, 293, 40, 1, 25, "Print"],
Cell[5941, 296, 40, 1, 25, "Print"],
Cell[5984, 299, 40, 1, 25, "Print"],
Cell[6027, 302, 40, 1, 25, "Print"],
Cell[6070, 305, 40, 1, 25, "Print"],
Cell[6113, 308, 40, 1, 25, "Print"],
Cell[6156, 311, 40, 1, 25, "Print"],
Cell[6199, 314, 40, 1, 25, "Print"],
Cell[6242, 317, 40, 1, 25, "Print"],
Cell[6285, 320, 40, 1, 25, "Print"],
Cell[6328, 323, 40, 1, 25, "Print"],
Cell[6371, 326, 40, 1, 25, "Print"],
Cell[6414, 329, 40, 1, 25, "Print"],
Cell[6457, 332, 40, 1, 25, "Print"],
Cell[6500, 335, 40, 1, 25, "Print"],
Cell[6543, 338, 40, 1, 25, "Print"],
Cell[6586, 341, 40, 1, 25, "Print"],
Cell[6629, 344, 40, 1, 25, "Print"],
Cell[6672, 347, 40, 1, 25, "Print"],
Cell[6715, 350, 40, 1, 25, "Print"],
Cell[6758, 353, 40, 1, 25, "Print"],
Cell[6801, 356, 40, 1, 25, "Print"],
Cell[6844, 359, 40, 1, 25, "Print"],
Cell[6887, 362, 40, 1, 25, "Print"],
Cell[6930, 365, 40, 1, 25, "Print"],
Cell[6973, 368, 40, 1, 25, "Print"],
Cell[7016, 371, 40, 1, 25, "Print"],
Cell[7059, 374, 40, 1, 25, "Print"],
Cell[7102, 377, 40, 1, 25, "Print"],
Cell[7145, 380, 40, 1, 25, "Print"],
Cell[7188, 383, 40, 1, 25, "Print"],
Cell[7231, 386, 40, 1, 25, "Print"],
Cell[7274, 389, 40, 1, 25, "Print"],
Cell[7317, 392, 40, 1, 25, "Print"],
Cell[7360, 395, 40, 1, 25, "Print"],
Cell[7403, 398, 40, 1, 25, "Print"],
Cell[7446, 401, 40, 1, 25, "Print"],
Cell[7489, 404, 40, 1, 25, "Print"],
Cell[7532, 407, 40, 1, 25, "Print"],
Cell[7575, 410, 41, 1, 25, "Print"],
Cell[7619, 413, 41, 1, 25, "Print"],
Cell[7663, 416, 41, 1, 25, "Print"],
Cell[7707, 419, 41, 1, 25, "Print"],
Cell[7751, 422, 41, 1, 25, "Print"],
Cell[7795, 425, 74, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7906, 431, 53, 1, 30, "Input"],
Cell[7962, 434, 36, 1, 29, "Output"]
}, Open  ]],
Cell[8013, 438, 244, 4, 71, "Text"],

Cell[CellGroupData[{
Cell[8282, 446, 57, 1, 30, "Input"],
Cell[8342, 449, 91, 1, 29, "Output"]
}, Open  ]],
Cell[8448, 453, 110, 3, 52, "Text"],

Cell[CellGroupData[{
Cell[8583, 460, 67, 1, 30, "Input"],
Cell[8653, 463, 36, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8726, 469, 33, 0, 64, "Subtitle"],
Cell[8762, 471, 271, 5, 90, "Text"],
Cell[9036, 478, 116, 2, 33, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

