(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     21027,        931]*)
(*NotebookOutlinePosition[     21678,        954]*)
(*  CellTagsIndexPosition[     21634,        950]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["RSA-160", "Title"],

Cell[BoxData[
    \(<< NumberTheory`FactorIntegerECM`\)], "Input"],

Cell["The next challenge to factor.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(n = 
      215274110271888970189601520131282542925777358884567598017049767677813314\
521885913567301105977349105960249790711158521430207931466520284014061994699492\
7570407753\ \)\)], "Input"],

Cell[BoxData[
    \(215274110271888970189601520131282542925777358884567598017049767677813314\
521885913567301105977349105960249790711158521430207931466520284014061994699492\
7570407753\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Length[IntegerDigits[n]]\)], "Input"],

Cell[BoxData[
    \(160\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Mod[n, 991889]\)], "Input"],

Cell[BoxData[
    \(970704\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Length[IntegerDigits[n, 2]]\)], "Input"],

Cell[BoxData[
    \(530\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\[Pi]\)], "Input"],

Cell[BoxData[
    \(\[Pi]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PI\)], "Input"],

Cell[BoxData[
    \(PI\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Pi\)], "Input"],

Cell[BoxData[
    \(\[Pi]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(N[\[Pi]]\)], "Input"],

Cell[BoxData[
    \(3.14159265358979311`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(pt = 
      108243104172681880494912306581940135359415602813058855197961024979421661\
47608107564112976420544463496910778389\ \)\)], "Input"],

Cell[BoxData[
    \(108243104172681880494912306581940135359415602813058855197961024979421661\
47608107564112976420544463496910778389\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(TrialDivision[n_] := 
      Module[{i, r, j}, \n\t\tr = n; \n\t\t
        For[i = 3, i < 1000000 \[And] i < \@n, i = i + 2, \n\t\t\t
          If[Mod[r, i] == 0, \n\t\t\t\tPrint[i]; \n\t\t\t\tr = r/i; 
            i = i - 2]; \n\t\t\tIf[Mod[i, 10000], Print["\<Passing \>", i]]]]
        \)], "Input"],

Cell[BoxData[
    \(TrialDivision[n_] := 
      Module[{i, r, j, stop}, \n\t\tr = n; j = 2; stop = \@n; \n\t\t
        While[j < 1000000 \[And] j < stop, \n\t\t\t
          For[i = j, i < j + 100000 \[And] i < stop, \(i++\), \n\t\t\t\t
            If[Mod[r, i] == 0, \n\t\t\t\t\tPrint[i]; \n\t\t\t\t\tr = r/i; 
              \(i--\)]]; \n\t\t\tj = j + 100000; \n\t\t\t
          If[PrimeQ[r], Print[r]; Break[]]; \n\t\t\tPrint["\<Passing \>", j]\n
          \t\t]; \n\t\tPrint["\<Finished\>"]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(TrialDivision[123123]\)], "Input"],

Cell[BoxData[
    \(3\)], "Print"],

Cell[BoxData[
    \(7\)], "Print"],

Cell[BoxData[
    \(11\)], "Print"],

Cell[BoxData[
    \(13\)], "Print"],

Cell[BoxData[
    \(41\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]100002\),
      SequenceForm[ "Passing ", 100002],
      Editable->False]], "Print"],

Cell[BoxData[
    \("Finished"\)], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TrialDivision[27]\)], "Input"],

Cell[BoxData[
    \(3\)], "Print"],

Cell[BoxData[
    \(3\)], "Print"],

Cell[BoxData[
    \(3\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]100002\),
      SequenceForm[ "Passing ", 100002],
      Editable->False]], "Print"],

Cell[BoxData[
    \("Finished"\)], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TrialDivision[pt]\)], "Input"],

Cell[BoxData[
    \(3\)], "Print"],

Cell[BoxData[
    \(3\)], "Print"],

Cell[BoxData[
    \(173\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]100002\),
      SequenceForm[ "Passing ", 100002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]200002\),
      SequenceForm[ "Passing ", 200002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]300002\),
      SequenceForm[ "Passing ", 300002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]400002\),
      SequenceForm[ "Passing ", 400002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]500002\),
      SequenceForm[ "Passing ", 500002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]600002\),
      SequenceForm[ "Passing ", 600002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]700002\),
      SequenceForm[ "Passing ", 700002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]800002\),
      SequenceForm[ "Passing ", 800002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]900002\),
      SequenceForm[ "Passing ", 900002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]1000002\),
      SequenceForm[ "Passing ", 1000002],
      Editable->False]], "Print"],

Cell[BoxData[
    \("Finished"\)], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(q = pt/\((3*3*173)\)\)], "Input"],

Cell[BoxData[
    \(695202981198984460468287132831985455102219671246363874103795921512020947\
1809959899879882094119758186840577\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[q]\)], "Input"],

Cell[BoxData[
    \(False\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(FactorIntegerECM[q]\)], "Input"],

Cell[BoxData[
    \(FactorIntegerECM[
      695202981198984460468287132831985455102219671246363874103795921512020947\
1809959899879882094119758186840577]\)], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[CellGroupData[{

Cell["p(9457)", "Subtitle"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n = 
      106152954147973372212569591652169182833017044403767639494262158461323654\
902767621593177028579512238092474\)], "Input"],

Cell[BoxData[
    \(106152954147973372212569591652169182833017044403767639494262158461323654\
902767621593177028579512238092474\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Length[IntegerDigits[n]]\)], "Input"],

Cell[BoxData[
    \(105\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[TrialDivision[n]]\)], "Input"],

Cell[BoxData[
    \(2\)], "Print"],

Cell[BoxData[
    \(3\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]100002\),
      SequenceForm[ "Passing ", 100002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]200002\),
      SequenceForm[ "Passing ", 200002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]300002\),
      SequenceForm[ "Passing ", 300002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]400002\),
      SequenceForm[ "Passing ", 400002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]500002\),
      SequenceForm[ "Passing ", 500002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]600002\),
      SequenceForm[ "Passing ", 600002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]700002\),
      SequenceForm[ "Passing ", 700002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]800002\),
      SequenceForm[ "Passing ", 800002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]900002\),
      SequenceForm[ "Passing ", 900002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]1000002\),
      SequenceForm[ "Passing ", 1000002],
      Editable->False]], "Print"],

Cell[BoxData[
    \("Finished"\)], "Print"],

Cell[BoxData[
    \({66.9000000000000127`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(p1 = 2; p2 = 3; \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n2 = n/\((p1\ p2)\)\)], "Input"],

Cell[BoxData[
    \(176921590246622287020949319420281971388361740672946065823770264102206091\
50461270265529504763252039682079\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Length[IntegerDigits[n2]]\)], "Input"],

Cell[BoxData[
    \(104\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[FactorInteger[n2]]\)], "Input"],

Cell[BoxData[
    \({0.549999999999954525`\ 
        Second, {{4789513, 1}, {
          36939369461283910706777352816514324397566462534488593271125950405021\
57348870599216565338639492583, 1}}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(p3 = 4789513; \)\)], "Input"],

Cell[BoxData[
    \(\(p4 = 
      369393694612839107067773528165143243975664625344885932711259504050215734\
8870599216565338639492583; \)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[{p3, p4}]\)], "Input"],

Cell[BoxData[
    \({True, True}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(n == p1\ p2\ p3\ p4\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["p(9551) "], "Subtitle"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n = 
      111828068897974505391301910053964938665080163355466380390248055212047629\
739548466816135451106431451550134\)], "Input"],

Cell[BoxData[
    \(111828068897974505391301910053964938665080163355466380390248055212047629\
739548466816135451106431451550134\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(p1 = 2; \)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n2 = n/p1\)], "Input"],

Cell[BoxData[
    \(559140344489872526956509550269824693325400816777331901951240276060238148\
69774233408067725553215725775067\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[TrialDivision[n2]]\)], "Input"],

Cell[BoxData[
    \(7\)], "Print"],

Cell[BoxData[
    \(29\)], "Print"],

Cell[BoxData[
    \(443\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]100002\),
      SequenceForm[ "Passing ", 100002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]200002\),
      SequenceForm[ "Passing ", 200002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]300002\),
      SequenceForm[ "Passing ", 300002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]400002\),
      SequenceForm[ "Passing ", 400002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]500002\),
      SequenceForm[ "Passing ", 500002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]600002\),
      SequenceForm[ "Passing ", 600002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]700002\),
      SequenceForm[ "Passing ", 700002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]800002\),
      SequenceForm[ "Passing ", 800002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]900002\),
      SequenceForm[ "Passing ", 900002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]1000002\),
      SequenceForm[ "Passing ", 1000002],
      Editable->False]], "Print"],

Cell[BoxData[
    \("Finished"\)], "Print"],

Cell[BoxData[
    \({69.1999999999998216`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(p2 = 7; p3 = 29; p4 = 443; \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n3 = n2/\((p2\ p3\ p4)\)\)], "Input"],

Cell[BoxData[
    \(621757547053645127774699541048854866978839770015603311447075221630662132\
012745981919822588411032323\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Length[IntegerDigits[n3]]\)], "Input"],

Cell[BoxData[
    \(99\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[FactorIntegerECM[n3]]\)], "Input"],

Cell[BoxData[
    \({18.1800000000000654`\ Second, 1028355420546414991961}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[FactorIntegerECM[n3]]\)], "Input"],

Cell[BoxData[
    \({16.37000000000012`\ Second, 2848123}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(p5 = 2848123; \)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n4 = n3/p5\)], "Input"],

Cell[BoxData[
    \(218304317283223065778654763522802514841823815198853178548494998857374534\
741914580908135845401\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[n4]\)], "Input"],

Cell[BoxData[
    \(False\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[FactorIntegerECM[n4]]\)], "Input"],

Cell[BoxData[
    \({30.7599999999999917`\ Second, 4014992483}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(p6 = 4014992483; \)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n5 = n4/p6\)], "Input"],

Cell[BoxData[
    \(543722854295623013196696845528820171496753995787874999487253084496931883\
15220708947\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[{n5, p5, p6}]\)], "Input"],

Cell[BoxData[
    \({False, True, True}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[FactorIntegerECM[n5]]\)], "Input"],

Cell[BoxData[
    \({112.539999999999973`\ Second, 4536472613999549}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[p7 = 4536472613999549]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[n6 = n5/p7]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p8 = n6\)], "Input"],

Cell[BoxData[
    \(11985586612331681281749240190859021916053272353706231361932967674703
    \)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(n == p1\ p2\ p3\ p4\ p5\ p6\ p7\ p8\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(time = 69.2 + 18.18 + 16.37 + 30.76 + 112.54\)], "Input"],

Cell[BoxData[
    \(247.050000000000036`\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["p(9587)", "Subtitle"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n = 
      178611094644857525093552335440538338412104026418232725177589352131274800\
204638632026157096742047437379531\)], "Input"],

Cell[BoxData[
    \(178611094644857525093552335440538338412104026418232725177589352131274800\
204638632026157096742047437379531\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[TrialDivision[n]]\)], "Input"],

Cell[BoxData[
    \(11\)], "Print"],

Cell[BoxData[
    \(887\)], "Print"],

Cell[BoxData[
    \(183059439012870272720664482361933318040487881949608204548108385908860100\
65044443171687721301839442183\)], "Print"],

Cell[BoxData[
    \("Finished"\)], "Print"],

Cell[BoxData[
    \({5.92999999999983629`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(p1 = 11; p2 = 887; 
    p3 = 183059439012870272720664482361933318040487881949608204548108385908860\
10065044443171687721301839442183; \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n == p1\ p2\ p3\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[{p1, p2, p3}]\)], "Input"],

Cell[BoxData[
    \({True, True, True}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["p(9601)", "Subtitle"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n = 
      214234610967362544093026307920774307370691516485806714800331684877093087\
043774763796572028893514257750348\)], "Input"],

Cell[BoxData[
    \(214234610967362544093026307920774307370691516485806714800331684877093087\
043774763796572028893514257750348\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[TrialDivision[n]]\)], "Input"],

Cell[BoxData[
    \(2\)], "Print"],

Cell[BoxData[
    \(2\)], "Print"],

Cell[BoxData[
    \(3\)], "Print"],

Cell[BoxData[
    \(3\)], "Print"],

Cell[BoxData[
    \(3\)], "Print"],

Cell[BoxData[
    \(17\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]100002\),
      SequenceForm[ "Passing ", 100002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]200002\),
      SequenceForm[ "Passing ", 200002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]300002\),
      SequenceForm[ "Passing ", 300002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]400002\),
      SequenceForm[ "Passing ", 400002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]500002\),
      SequenceForm[ "Passing ", 500002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]600002\),
      SequenceForm[ "Passing ", 600002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]700002\),
      SequenceForm[ "Passing ", 700002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]800002\),
      SequenceForm[ "Passing ", 800002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]900002\),
      SequenceForm[ "Passing ", 900002],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Passing "\[InvisibleSpace]1000002\),
      SequenceForm[ "Passing ", 1000002],
      Editable->False]], "Print"],

Cell[BoxData[
    \("Finished"\)], "Print"],

Cell[BoxData[
    \({64.5900000000001472`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(p1 = 2\^2; p2 = 3\^3; p3 = 17; \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n2 = n/\((p1\ p2\ p3)\)\)], "Input"],

Cell[BoxData[
    \(116685517956079817044131975991707139090790586321245487364015078909092095\
339746603375039231423482711193\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[FactorIntegerECM[n2]]\)], "Input"],

Cell[BoxData[
    \({16.4200000000000745`\ Second, 1668773}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[p4 = 1668773]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[n3 = n2/p4]\)], "Input"],

Cell[BoxData[
    \(False\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[FactorIntegerECM[n3]]\)], "Input"],

Cell[BoxData[
    \($Aborted\)], "Output"]
}, Open  ]],

Cell["I can't be bothered allowing this to run all day.", "Text"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"Microsoft Windows 3.0",
ScreenRectangle->{{0, 1024}, {0, 740}},
WindowSize->{839, 596},
WindowMargins->{{51, Automatic}, {Automatic, 13}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1731, 51, 24, 0, 105, "Title"],
Cell[1758, 53, 66, 1, 30, "Input"],
Cell[1827, 56, 45, 0, 33, "Text"],

Cell[CellGroupData[{
Cell[1897, 60, 214, 4, 70, "Input"],
Cell[2114, 66, 198, 3, 48, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2349, 74, 57, 1, 30, "Input"],
Cell[2409, 77, 37, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2483, 83, 47, 1, 30, "Input"],
Cell[2533, 86, 40, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2610, 92, 60, 1, 30, "Input"],
Cell[2673, 95, 37, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2747, 101, 38, 1, 30, "Input"],
Cell[2788, 104, 39, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2864, 110, 35, 1, 30, "Input"],
Cell[2902, 113, 36, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2975, 119, 35, 1, 30, "Input"],
Cell[3013, 122, 39, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3089, 128, 41, 1, 30, "Input"],
Cell[3133, 131, 54, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3224, 137, 163, 3, 70, "Input"],
Cell[3390, 142, 146, 2, 48, "Output"]
}, Open  ]],
Cell[3551, 147, 321, 6, 156, "Input"],
Cell[3875, 155, 506, 8, 254, "Input"],

Cell[CellGroupData[{
Cell[4406, 167, 54, 1, 30, "Input"],
Cell[4463, 170, 34, 1, 25, "Print"],
Cell[4500, 173, 34, 1, 25, "Print"],
Cell[4537, 176, 35, 1, 25, "Print"],
Cell[4575, 179, 35, 1, 25, "Print"],
Cell[4613, 182, 35, 1, 25, "Print"],
Cell[4651, 185, 149, 3, 25, "Print"],
Cell[4803, 190, 43, 1, 25, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4883, 196, 50, 1, 30, "Input"],
Cell[4936, 199, 34, 1, 25, "Print"],
Cell[4973, 202, 34, 1, 25, "Print"],
Cell[5010, 205, 34, 1, 25, "Print"],
Cell[5047, 208, 149, 3, 25, "Print"],
Cell[5199, 213, 43, 1, 25, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5279, 219, 50, 1, 30, "Input"],
Cell[5332, 222, 34, 1, 25, "Print"],
Cell[5369, 225, 34, 1, 25, "Print"],
Cell[5406, 228, 36, 1, 25, "Print"],
Cell[5445, 231, 149, 3, 25, "Print"],
Cell[5597, 236, 149, 3, 25, "Print"],
Cell[5749, 241, 149, 3, 25, "Print"],
Cell[5901, 246, 149, 3, 25, "Print"],
Cell[6053, 251, 149, 3, 25, "Print"],
Cell[6205, 256, 149, 3, 25, "Print"],
Cell[6357, 261, 149, 3, 25, "Print"],
Cell[6509, 266, 149, 3, 25, "Print"],
Cell[6661, 271, 149, 3, 25, "Print"],
Cell[6813, 276, 151, 3, 25, "Print"],
Cell[6967, 281, 43, 1, 25, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7047, 287, 53, 1, 30, "Input"],
Cell[7103, 290, 142, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7282, 297, 42, 1, 30, "Input"],
Cell[7327, 300, 39, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7403, 306, 52, 1, 30, "Input"],
Cell[7458, 309, 167, 3, 67, "Output"]
}, Open  ]],
Cell[7640, 315, 26, 0, 30, "Input"],

Cell[CellGroupData[{
Cell[7691, 319, 27, 0, 64, "Subtitle"],

Cell[CellGroupData[{
Cell[7743, 323, 151, 3, 50, "Input"],
Cell[7897, 328, 141, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8075, 335, 57, 1, 30, "Input"],
Cell[8135, 338, 37, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8209, 344, 57, 1, 30, "Input"],
Cell[8269, 347, 34, 1, 25, "Print"],
Cell[8306, 350, 34, 1, 25, "Print"],
Cell[8343, 353, 149, 3, 25, "Print"],
Cell[8495, 358, 149, 3, 25, "Print"],
Cell[8647, 363, 149, 3, 25, "Print"],
Cell[8799, 368, 149, 3, 25, "Print"],
Cell[8951, 373, 149, 3, 25, "Print"],
Cell[9103, 378, 149, 3, 25, "Print"],
Cell[9255, 383, 149, 3, 25, "Print"],
Cell[9407, 388, 149, 3, 25, "Print"],
Cell[9559, 393, 149, 3, 25, "Print"],
Cell[9711, 398, 151, 3, 25, "Print"],
Cell[9865, 403, 43, 1, 25, "Print"],
Cell[9911, 406, 70, 1, 29, "Output"]
}, Open  ]],
Cell[9996, 410, 49, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[10070, 415, 52, 1, 30, "Input"],
Cell[10125, 418, 140, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10302, 425, 58, 1, 30, "Input"],
Cell[10363, 428, 37, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10437, 434, 58, 1, 30, "Input"],
Cell[10498, 437, 207, 4, 48, "Output"]
}, Open  ]],
Cell[10720, 444, 51, 1, 30, "Input"],
Cell[10774, 447, 150, 3, 30, "Input"],

Cell[CellGroupData[{
Cell[10949, 454, 49, 1, 30, "Input"],
Cell[11001, 457, 46, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11084, 463, 52, 1, 30, "Input"],
Cell[11139, 466, 38, 1, 29, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[11226, 473, 38, 0, 64, "Subtitle"],

Cell[CellGroupData[{
Cell[11289, 477, 151, 3, 50, "Input"],
Cell[11443, 482, 141, 2, 29, "Output"]
}, Open  ]],
Cell[11599, 487, 45, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[11669, 492, 42, 1, 30, "Input"],
Cell[11714, 495, 140, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11891, 502, 58, 1, 30, "Input"],
Cell[11952, 505, 34, 1, 25, "Print"],
Cell[11989, 508, 35, 1, 25, "Print"],
Cell[12027, 511, 36, 1, 25, "Print"],
Cell[12066, 514, 149, 3, 25, "Print"],
Cell[12218, 519, 149, 3, 25, "Print"],
Cell[12370, 524, 149, 3, 25, "Print"],
Cell[12522, 529, 149, 3, 25, "Print"],
Cell[12674, 534, 149, 3, 25, "Print"],
Cell[12826, 539, 149, 3, 25, "Print"],
Cell[12978, 544, 149, 3, 25, "Print"],
Cell[13130, 549, 149, 3, 25, "Print"],
Cell[13282, 554, 149, 3, 25, "Print"],
Cell[13434, 559, 151, 3, 25, "Print"],
Cell[13588, 564, 43, 1, 25, "Print"],
Cell[13634, 567, 70, 1, 29, "Output"]
}, Open  ]],
Cell[13719, 571, 60, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[13804, 576, 57, 1, 30, "Input"],
Cell[13864, 579, 135, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14036, 586, 58, 1, 30, "Input"],
Cell[14097, 589, 36, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14170, 595, 61, 1, 30, "Input"],
Cell[14234, 598, 88, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14359, 604, 61, 1, 30, "Input"],
Cell[14423, 607, 71, 1, 29, "Output"]
}, Open  ]],
Cell[14509, 611, 51, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[14585, 616, 43, 1, 30, "Input"],
Cell[14631, 619, 129, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14797, 626, 43, 1, 30, "Input"],
Cell[14843, 629, 39, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14919, 635, 61, 1, 30, "Input"],
Cell[14983, 638, 76, 1, 29, "Output"]
}, Open  ]],
Cell[15074, 642, 54, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[15153, 647, 43, 1, 30, "Input"],
Cell[15199, 650, 119, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15355, 657, 53, 1, 30, "Input"],
Cell[15411, 660, 53, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15501, 666, 61, 1, 30, "Input"],
Cell[15565, 669, 82, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15684, 675, 62, 1, 30, "Input"],
Cell[15749, 678, 38, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15824, 684, 51, 1, 30, "Input"],
Cell[15878, 687, 38, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15953, 693, 40, 1, 30, "Input"],
Cell[15996, 696, 107, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16140, 703, 68, 1, 30, "Input"],
Cell[16211, 706, 38, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16286, 712, 77, 1, 30, "Input"],
Cell[16366, 715, 54, 1, 29, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[16469, 722, 27, 0, 64, "Subtitle"],

Cell[CellGroupData[{
Cell[16521, 726, 151, 3, 50, "Input"],
Cell[16675, 731, 141, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16853, 738, 57, 1, 30, "Input"],
Cell[16913, 741, 35, 1, 25, "Print"],
Cell[16951, 744, 36, 1, 25, "Print"],
Cell[16990, 747, 136, 2, 25, "Print"],
Cell[17129, 751, 43, 1, 25, "Print"],
Cell[17175, 754, 70, 1, 29, "Output"]
}, Open  ]],
Cell[17260, 758, 167, 3, 50, "Input"],

Cell[CellGroupData[{
Cell[17452, 765, 48, 1, 30, "Input"],
Cell[17503, 768, 38, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[17578, 774, 53, 1, 30, "Input"],
Cell[17634, 777, 52, 1, 29, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[17735, 784, 27, 0, 64, "Subtitle"],

Cell[CellGroupData[{
Cell[17787, 788, 151, 3, 50, "Input"],
Cell[17941, 793, 141, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18119, 800, 57, 1, 30, "Input"],
Cell[18179, 803, 34, 1, 25, "Print"],
Cell[18216, 806, 34, 1, 25, "Print"],
Cell[18253, 809, 34, 1, 25, "Print"],
Cell[18290, 812, 34, 1, 25, "Print"],
Cell[18327, 815, 34, 1, 25, "Print"],
Cell[18364, 818, 35, 1, 25, "Print"],
Cell[18402, 821, 149, 3, 25, "Print"],
Cell[18554, 826, 149, 3, 25, "Print"],
Cell[18706, 831, 149, 3, 25, "Print"],
Cell[18858, 836, 149, 3, 25, "Print"],
Cell[19010, 841, 149, 3, 25, "Print"],
Cell[19162, 846, 149, 3, 25, "Print"],
Cell[19314, 851, 149, 3, 25, "Print"],
Cell[19466, 856, 149, 3, 25, "Print"],
Cell[19618, 861, 149, 3, 25, "Print"],
Cell[19770, 866, 151, 3, 25, "Print"],
Cell[19924, 871, 43, 1, 25, "Print"],
Cell[19970, 874, 70, 1, 29, "Output"]
}, Open  ]],
Cell[20055, 878, 64, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[20144, 883, 56, 1, 30, "Input"],
Cell[20203, 886, 138, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20378, 893, 61, 1, 30, "Input"],
Cell[20442, 896, 73, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20552, 902, 53, 1, 30, "Input"],
Cell[20608, 905, 38, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20683, 911, 51, 1, 30, "Input"],
Cell[20737, 914, 39, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20813, 920, 61, 1, 30, "Input"],
Cell[20877, 923, 42, 1, 29, "Output"]
}, Open  ]],
Cell[20934, 927, 65, 0, 33, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

